
set nocount on
set xact_abort on
go

use Pass2012
go

if exists(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'LargeRow'
)
	drop table dbo.LargeRow
go

create table dbo.LargeRow
(
	ID int not null,
	IntField int not null, 
	CharField char(2000) not null,
	
	constraint PK_LargeRow
	primary key clustered(Id)
)
go


if exists(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'SmallRow'
)
	drop table dbo.SmallRow
go

create table dbo.SmallRow
(
	ID int not null,
	IntField int not null, 
	CharField varchar(2000) not null,
	
	constraint PK_SmallRow
	primary key clustered(Id)
)
go

/*
if exists(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'MainData'
)
	drop table dbo.MainData
go

create table dbo.MainData
(
	ID int not null,
	IntField int not null, 
	
	constraint PK_MainData
	primary key clustered(Id)
)
go


if exists(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'BlobData'
)
	drop table dbo.BlobData
go

create table dbo.BlobData
(
	ID int not null,
	CharField char(2000) not null,
	
	constraint PK_BlobData
	primary key clustered(Id),

	constraint FK_BlobData_MainData
	foreign key(ID) references dbo.MainData(ID)
	on delete cascade
)
go
*/

;WITH N1(C) AS (SELECT 0 UNION ALL SELECT 0) -- 2 rows
,N2(C) AS (SELECT 0 FROM N1 AS T1 CROSS JOIN N1 AS T2) -- 4 rows
,N3(C) AS (SELECT 0 FROM N2 AS T1 CROSS JOIN N2 AS T2) -- 16 rows
,N4(C) AS (SELECT 0 FROM N3 AS T1 CROSS JOIN N3 AS T2) -- 256 rows
,N5(C) AS (SELECT 0 FROM N4 AS T1 CROSS JOIN N4 AS T2) -- 65,536 rows
,IDs(ID) AS (SELECT ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) FROM N5)
insert into dbo.LargeRow(ID,IntField,CharField)
	select ID, ID, 'Placeholder'
	from IDs
go

;WITH N1(C) AS (SELECT 0 UNION ALL SELECT 0) -- 2 rows
,N2(C) AS (SELECT 0 FROM N1 AS T1 CROSS JOIN N1 AS T2) -- 4 rows
,N3(C) AS (SELECT 0 FROM N2 AS T1 CROSS JOIN N2 AS T2) -- 16 rows
,N4(C) AS (SELECT 0 FROM N3 AS T1 CROSS JOIN N3 AS T2) -- 256 rows
,N5(C) AS (SELECT 0 FROM N4 AS T1 CROSS JOIN N4) -- 65,536 rows
,IDs(ID) AS (SELECT ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) FROM N5)
insert into dbo.SmallRow(ID,IntField,CharField)
	select ID, ID, 'Placeholder'
	from IDs
go
	